// winlirc.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "winlirc.h"
#include "server.h"
#include "ammo.h"				// Required for ATI Remote Wonder plug-in SDK API

#define WINLIRC_REGPATH		"Software\\ATI Technologies\\Multimedia\\Remote Control\\Plug-Ins\\WinLIRC"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CWinlircApp

BEGIN_MESSAGE_MAP(CWinlircApp, CWinApp)
	//{{AFX_MSG_MAP(CWinlircApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWinlircApp construction

CWinlircApp::CWinlircApp()
{
	// Place all significant initialization in InitInstance
	server = NULL;
	m_bMouseMsg = TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CWinlircApp object

CWinlircApp theApp;

BOOL CWinlircApp::InitInstance() 
{
	HKEY hKey = NULL;
	if (RegOpenKeyEx(HKEY_CURRENT_USER, WINLIRC_REGPATH, 0, KEY_READ, &hKey) == ERROR_SUCCESS)
	{
		DWORD dwType = REG_DWORD;
		DWORD dwValue = 0;
		DWORD dwSize = sizeof(DWORD);
		if (RegQueryValueEx(hKey, "Mouse", 0, &dwType, (LPBYTE)&dwValue, &dwSize) == ERROR_SUCCESS)
		{
			m_bMouseMsg = dwValue;
		}

		RegCloseKey(hKey);
	}

	return CWinApp::InitInstance();
}

int CWinlircApp::ExitInstance() 
{
	if (server != NULL)
	{
		delete server;
		server = NULL;
	}
	
	return CWinApp::ExitInstance();
}

void CWinlircApp::StartServer()
{
	if (server != NULL) return;

	if ((server = new Cserver) == NULL)
	{
		MessageBox(NULL, "Could not create server object.", "WinLIRC", MB_OK|MB_ICONERROR);
		return;
	}

	HKEY hKey = NULL;
	if (RegOpenKeyEx(HKEY_CURRENT_USER, WINLIRC_REGPATH, 0, KEY_READ, &hKey) == ERROR_SUCCESS)
	{
		DWORD dwType = REG_DWORD;
		DWORD dwValue = 0;
		DWORD dwSize = sizeof(DWORD);
		if (RegQueryValueEx(hKey, "Port", 0, &dwType, (LPBYTE)&dwValue, &dwSize) == ERROR_SUCCESS)
		{
			server->settcpport(dwValue);
		}

		if (RegQueryValueEx(hKey, "LocalOnly", 0, &dwType, (LPBYTE)&dwValue, &dwSize) == ERROR_SUCCESS)
		{
			server->setlocalonly(dwValue ? true : false);
		}

		RegCloseKey(hKey);
	}

	if (server->init() == false)
	{
		MessageBox(NULL, "Could not start server.", "WinLIRC", MB_OK|MB_ICONERROR);

		delete server;
		server = NULL;
		return;
	}
}

BOOL CWinlircApp::HandleKey(WORD wKeyEvent, WORD wState, BYTE bRepeat, LPCTSTR szKey)
{
	if (server == NULL) return FALSE;

	CString str;
	str.Format("00000000%04x%04x %02x %s atiremotewonder\n", 1, wKeyEvent, bRepeat, szKey);

	server->send(str);

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAbout dialog


CAbout::CAbout(CWnd* pParent /*=NULL*/)
	: CDialog(CAbout::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAbout)
	m_nPort = 8765;
	m_bLocalOnly = TRUE;
	m_bMouseMsg = TRUE;
	//}}AFX_DATA_INIT
}


void CAbout::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAbout)
	DDX_Text(pDX, IDC_PORT, m_nPort);
	DDX_Check(pDX, IDC_LOCAL_ONLY, m_bLocalOnly);
	DDX_Check(pDX, IDC_MOUSE, m_bMouseMsg);
	DDV_MinMaxInt(pDX, m_nPort, 0, 65535);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAbout, CDialog)
	//{{AFX_MSG_MAP(CAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAbout message handlers

BOOL CAbout::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAbout::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

/////////////////////////////////////////////////////////////////////////////
// AMMO externs

extern "C" {

/*
 * Function:	WhatKeysDoYouWant
 *
 * Purpose:		Determines what groups of keys should be re-directed to
 *				the plug-in.
 *
 * Inputs:		None
 *
 * Returns:		A bit mask which indicates the groups of keys that should
 *				be re-directed to this plug-in.
 *
 * When called: This function is called once when the plug-in is first loaded,
 *				and again after calling Configure().
 *
 * Author:		ATI
 *
 * Copyright:	Copyright (c) 2002 ATI Technologies Inc
 */
__declspec(dllexport) DWORD WhatKeysDoYouWant (void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	theApp.StartServer();

	// For winamp we need to control the following keys:
	//
	// CUSTOM_MAPPED - provide list of programmable options
	// VOLUME_GROUP - adjust the playback volume
	// PLAY_GROUP - play, pause, stop, FF, RW
	// SETUP - toggle the preferences dialog
	// MENU - toggle the playlist editor
	// RESIZE - toggle doublesize mode
	// STOPWATCH - add current track as a bookmark

	return (CUSTOM_RAW|MOUSE_GROUP|CHANNEL_GROUP|VOLUME_GROUP|NUMBER_GROUP|CURSOR_GROUP|PLAY_GROUP|MENU|SETUP|ENTER|RECORD|STOPWATCH|RESIZE|WEB_LAUNCH);		
}

/*
 * Function:	EnumerateProgrammableFunction
 *
 * Purpose:		Enumerate the descriptions of the programamble
 *				functions provided by this plug-in.
 *
 * Inputs:		wIndex - index of requested description
 *
 * Returns:		Pointer to the programmable function description
 *				or NULL if wIndex is greater than the number of
 *				programmable functions provided by this plug-in.
 *
 * When called:	This function is called after any call to WhatKeysDoYouWant()
 *				that returns a request for custom mapped keys (CUSTOM_MAPPED).
 *
 * Author:		ATI
 *
 * Copyright:	Copyright (c) 2002 ATI Technologies Inc
 */
__declspec(dllexport) char *EnumerateProgrammableFunction (WORD wIndex)
{	
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	// none for now ;)
	return NULL;
}


/*
 * Function:	Configure
 *
 * Purpose:		Displays any configuration/setup page required by
 *				this plug-in. 
 *
 * Inputs:		hWnd - handle to the parent window. The parent window
 *				is used to ensure correct modal behaviour when creating 
 *				dialog and message boxes in this plug-in.
 *
 * Returns:		None
 *
 * When called: This function is called when the "Configure" button in the
 *				ATI Remote Wonder software is pressed.
 *
 * Author:		ATI
 *
 * Copyright:	Copyright (c) 2002 ATI Technologies Inc
 */
__declspec(dllexport) void Configure (HANDLE hWnd)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	CAbout about(CWnd::FromHandle((HWND)hWnd));

	if (theApp.server != NULL)
	{
		about.m_nPort = theApp.server->gettcpport();
		about.m_bLocalOnly = theApp.server->islocalonly();
	}

	about.m_bMouseMsg = theApp.m_bMouseMsg;

	if (about.DoModal() == IDOK)
	{
		theApp.m_bMouseMsg = about.m_bMouseMsg;

		HKEY hKey = NULL;
		if (RegCreateKeyEx(HKEY_CURRENT_USER, WINLIRC_REGPATH, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL) == ERROR_SUCCESS)
		{
			RegSetValueEx(hKey, "Port", 0, REG_DWORD, (CONST BYTE *)&about.m_nPort, sizeof(DWORD));
			RegSetValueEx(hKey, "LocalOnly", 0, REG_DWORD, (CONST BYTE *)&about.m_bLocalOnly, sizeof(DWORD));
			RegSetValueEx(hKey, "Mouse", 0, REG_DWORD, (CONST BYTE *)&about.m_bMouseMsg, sizeof(DWORD));
			RegCloseKey(hKey);

			if (theApp.server != NULL)
			{
				if ((theApp.server->gettcpport() != about.m_nPort) ||
					((BOOL)theApp.server->islocalonly() != about.m_bLocalOnly))
				{
					delete theApp.server;
					theApp.server = NULL;

					theApp.StartServer();
				}
			}
		}
	}
}


/*
 * Function:	AreYouInFocus
 *
 * Purpose:		Determines if this plug-in is currently in-focus.
 *
 * Inputs:		None
 *
 * Returns:		TRUE if the plug-in is currently in focus, FALSE
 *				otherwise.
 *
 * When called:	This function is called when a key event occurs that
 *				the plug-in has requested.
 *
 * Author:		ATI
 *
 * Copyright:	Copyright (c) 2002 ATI Technologies Inc
 */
__declspec(dllexport) int AreYouInFocus (void)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	if (theApp.server == NULL) return FALSE;

	if (theApp.server->hasclients()) return TRUE;

	// not in focus
	return FALSE;
}


/*
 * Function:	HandleKey
 *
 * Purpose:		Handles remote control keys.
 *
 * Inputs:		bCustom   - TRUE if wKeyEvent has been mapped to a custom
 *						    programamble option.
 *				wKeyEvent - Remote control key code for button that was
 *							pressed.
 *				wState    - RMCTRL_KEY_ON, when button is first pressed
 *						    RMCTRL_KEY_REPEAT, when button is held down
 *						    RMCTRL_KEY_OFF, when button is released
 *
 * Returns:		TRUE if the plug-in handled the command, FALSE otherwise.
 *
 * When called: This function is called whenever a key event occurs that
 *				the plug-in has requested when the plug-in is in focus.
 *
 * Author:		ATI
 *
 * Copyright:	Copyright (c) 2002 ATI Technologies Inc
 */
__declspec(dllexport) BOOL HandleKey (BOOL bCustom, WORD wKeyEvent, WORD wState)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState());

	if (theApp.server == NULL) return FALSE;

	static int nRepeat = 0;

	// Handle non-programmed keys
	if (wState == RMCTRL_KEY_ON)
	{
		// reset repeat flag
		nRepeat = 0;

		switch (wKeyEvent)
		{
		case RMCTRL_0:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "0");
		case RMCTRL_1:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "1");
		case RMCTRL_2:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "2");
		case RMCTRL_3:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "3");
		case RMCTRL_4:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "4");
		case RMCTRL_5:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "5");
		case RMCTRL_6:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "6");
		case RMCTRL_7:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "7");
		case RMCTRL_8:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "8");
		case RMCTRL_9:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "9");
		case RMCTRL_CHANNELUP:		return theApp.HandleKey(wKeyEvent, wState, nRepeat, "channel_up");
		case RMCTRL_CHANNELDOWN:	return theApp.HandleKey(wKeyEvent, wState, nRepeat, "channel_down");
		case RMCTRL_VOLUMEUP:		return theApp.HandleKey(wKeyEvent, wState, nRepeat, "vol_up");
		case RMCTRL_VOLUMEDOWN:		return theApp.HandleKey(wKeyEvent, wState, nRepeat, "vol_down");
		case RMCTRL_MUTE:			return theApp.HandleKey(wKeyEvent, wState, nRepeat, "mute");
		case RMCTRL_MENU:			return theApp.HandleKey(wKeyEvent, wState, nRepeat, "menu");
		case RMCTRL_SETUP:			return theApp.HandleKey(wKeyEvent, wState, nRepeat, "setup");
		case RMCTRL_UP:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "up");
		case RMCTRL_DOWN:			return theApp.HandleKey(wKeyEvent, wState, nRepeat, "down");
		case RMCTRL_LEFT:			return theApp.HandleKey(wKeyEvent, wState, nRepeat, "left");
		case RMCTRL_RIGHT:			return theApp.HandleKey(wKeyEvent, wState, nRepeat, "right");
		case RMCTRL_ENTER:			return theApp.HandleKey(wKeyEvent, wState, nRepeat, "ok");
		case RMCTRL_FF:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "fastforward");
		case RMCTRL_RW:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "rewind");
		case RMCTRL_PLAY:			return theApp.HandleKey(wKeyEvent, wState, nRepeat, "play");
		case RMCTRL_PAUSE:			return theApp.HandleKey(wKeyEvent, wState, nRepeat, "pause");
		case RMCTRL_STOP:			return theApp.HandleKey(wKeyEvent, wState, nRepeat, "stop");
		case RMCTRL_RECORD:			return theApp.HandleKey(wKeyEvent, wState, nRepeat, "record");
		case RMCTRL_STOPWATCH:		return theApp.HandleKey(wKeyEvent, wState, nRepeat, "stopwatch");
		case RMCTRL_A:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "pb_a");
		case RMCTRL_B:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "pb_b");
		case RMCTRL_C:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "pb_c");
		case RMCTRL_D:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "pb_d");
		case RMCTRL_E:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "pb_e");
		case RMCTRL_F:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "pb_f");
		case RMCTRL_RESIZE:			return theApp.HandleKey(wKeyEvent, wState, nRepeat, "fullscreen");
		case RMCTRL_WEB_LAUNCH:		return theApp.HandleKey(wKeyEvent, wState, nRepeat, "web");
		}

		if (theApp.m_bMouseMsg)
		{
			switch (wKeyEvent)
			{
			case RMCTRL_HAND:					return theApp.HandleKey(wKeyEvent, wState, nRepeat, "hand");
			case RMCTRL_LEFTMOUSE:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "leftmouse");
			case RMCTRL_RIGHTMOUSE:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "rightmouse");
			case RMCTRL_LEFTMOUSEDOUBLECLICK:	return theApp.HandleKey(wKeyEvent, wState, nRepeat, "leftmouse_dlbclk");
			case RMCTRL_RIGHTMOUSEDOUBLECLICK:	return theApp.HandleKey(wKeyEvent, wState, nRepeat, "rightmouse_dlbclk");
			case RMCTRL_DIRPADRIGHT:			return theApp.HandleKey(wKeyEvent, wState, nRepeat, "dirpad_right");
			case RMCTRL_DIRPADUP:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "dirpad_up");
			case RMCTRL_DIRPADLEFT:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "dirpad_left");
			case RMCTRL_DIRPADDOWN:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "dirpad_down");
			case RMCTRL_DIRPADRIGHTUP:			return theApp.HandleKey(wKeyEvent, wState, nRepeat, "dirpad_rightup");
			case RMCTRL_DIRPADRIGHTDOWN:		return theApp.HandleKey(wKeyEvent, wState, nRepeat, "dirpad_rightdown:");
			case RMCTRL_DIRPADLEFTUP:			return theApp.HandleKey(wKeyEvent, wState, nRepeat, "dirpad_leftup");
			case RMCTRL_DIRPADLEFTDOWN:			return theApp.HandleKey(wKeyEvent, wState, nRepeat, "dirpad_leftdown");
			}
		}
	}
	else if (wState == RMCTRL_KEY_OFF)
	{
		switch (wKeyEvent)
		{
		case RMCTRL_0:				return TRUE;
		case RMCTRL_1:				return TRUE;
		case RMCTRL_2:				return TRUE;
		case RMCTRL_3:				return TRUE;
		case RMCTRL_4:				return TRUE;
		case RMCTRL_5:				return TRUE;
		case RMCTRL_6:				return TRUE;
		case RMCTRL_7:				return TRUE;
		case RMCTRL_8:				return TRUE;
		case RMCTRL_9:				return TRUE;
		case RMCTRL_CHANNELUP:		return TRUE;
		case RMCTRL_CHANNELDOWN:	return TRUE;
		case RMCTRL_VOLUMEUP:		return TRUE;
		case RMCTRL_VOLUMEDOWN:		return TRUE;
		case RMCTRL_MUTE:			return TRUE;
		case RMCTRL_MENU:			return TRUE;
		case RMCTRL_SETUP:			return TRUE;
		case RMCTRL_UP:				return TRUE;
		case RMCTRL_DOWN:			return TRUE;
		case RMCTRL_LEFT:			return TRUE;
		case RMCTRL_RIGHT:			return TRUE;
		case RMCTRL_ENTER:			return TRUE;
		case RMCTRL_FF:				return TRUE;
		case RMCTRL_RW:				return TRUE;
		case RMCTRL_PLAY:			return TRUE;
		case RMCTRL_PAUSE:			return TRUE;
		case RMCTRL_STOP:			return TRUE;
		case RMCTRL_RECORD:			return TRUE;
		case RMCTRL_STOPWATCH:		return TRUE;
		case RMCTRL_A:				return TRUE;
		case RMCTRL_B:				return TRUE;
		case RMCTRL_C:				return TRUE;
		case RMCTRL_D:				return TRUE;
		case RMCTRL_E:				return TRUE;
		case RMCTRL_F:				return TRUE;
		case RMCTRL_RESIZE:			return TRUE;
		case RMCTRL_WEB_LAUNCH:		return TRUE;
		}

		if (theApp.m_bMouseMsg)
		{
			switch (wKeyEvent)
			{
			case RMCTRL_HAND:					return TRUE;
			case RMCTRL_LEFTMOUSE:				return TRUE;
			case RMCTRL_RIGHTMOUSE:				return TRUE;
			case RMCTRL_LEFTMOUSEDOUBLECLICK:	return TRUE;
			case RMCTRL_RIGHTMOUSEDOUBLECLICK:	return TRUE;
			case RMCTRL_DIRPADRIGHT:			return TRUE;
			case RMCTRL_DIRPADUP:				return TRUE;
			case RMCTRL_DIRPADLEFT:				return TRUE;
			case RMCTRL_DIRPADDOWN:				return TRUE;
			case RMCTRL_DIRPADRIGHTUP:			return TRUE;
			case RMCTRL_DIRPADRIGHTDOWN:		return TRUE;
			case RMCTRL_DIRPADLEFTUP:			return TRUE;
			case RMCTRL_DIRPADLEFTDOWN:			return TRUE;
			}
		}
	}
	else if (wState == RMCTRL_KEY_REPEAT)
	{
		// increment repeat flag
		nRepeat++;

		switch (wKeyEvent)
		{
		case RMCTRL_CHANNELUP:		return theApp.HandleKey(wKeyEvent, wState, nRepeat, "channel_up");
		case RMCTRL_CHANNELDOWN:	return theApp.HandleKey(wKeyEvent, wState, nRepeat, "channel_down");
		case RMCTRL_VOLUMEUP:		return theApp.HandleKey(wKeyEvent, wState, nRepeat, "vol_up");
		case RMCTRL_VOLUMEDOWN:		return theApp.HandleKey(wKeyEvent, wState, nRepeat, "vol_down");
		case RMCTRL_STOPWATCH:		return theApp.HandleKey(wKeyEvent, wState, nRepeat, "stopwatch");
		}

		if (theApp.m_bMouseMsg)
		{
			switch (wKeyEvent)
			{
			case RMCTRL_DIRPADRIGHT:			return theApp.HandleKey(wKeyEvent, wState, nRepeat, "dirpad_right");
			case RMCTRL_DIRPADUP:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "dirpad_up");
			case RMCTRL_DIRPADLEFT:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "dirpad_left");
			case RMCTRL_DIRPADDOWN:				return theApp.HandleKey(wKeyEvent, wState, nRepeat, "dirpad_down");
			case RMCTRL_DIRPADRIGHTUP:			return theApp.HandleKey(wKeyEvent, wState, nRepeat, "dirpad_rightup");
			case RMCTRL_DIRPADRIGHTDOWN:		return theApp.HandleKey(wKeyEvent, wState, nRepeat, "dirpad_rightdown:");
			case RMCTRL_DIRPADLEFTUP:			return theApp.HandleKey(wKeyEvent, wState, nRepeat, "dirpad_leftup");
			case RMCTRL_DIRPADLEFTDOWN:			return theApp.HandleKey(wKeyEvent, wState, nRepeat, "dirpad_leftdown");
			}
		}
	}

	// The plug-in did not process this key. It is important to return FALSE
	// if the key was not processed so that other plug-ins or the ATI Remote Wonder
	// software can handle the key press.
	return FALSE;
}

} /* extern "C" */

