;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;General installer configuration
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Name "WinLIRC Plugin"
BrandingText " "
OutFile winlirc_rw.exe
;WindowIcon off

SetDatablockOptimize on
SetDateSave on
SetOverwrite on
CRCCheck on

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Install directory configuration
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DirText "This will install the WinLIRC for ATI Remote Wonder on your computer:" "ATI Remote Wonder directory (autodetected):"
InstallDir "$PROGRAMFILES\Ammo Plugin"
InstallDirRegKey HKLM "SOFTWARE\ATI Technologies\Multimedia\Remote Wonder" "PlugInsPath"
AutoCloseWindow true
ShowInstDetails show

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Component page configuration
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Section "WinLIRC (required)"
  SetOutPath $INSTDIR
  File Release\winlirc.dll

  WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\WinLIRC" "A" 0
  WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\WinLIRC" "B" 0
  WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\WinLIRC" "C" 0
  WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\WinLIRC" "D" 0
  WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\WinLIRC" "E" 0
  WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\WinLIRC" "F" 0
  WriteRegDWORD HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\WinLIRC" "Enabled" 1
  WriteRegStr   HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\WinLIRC" "Filename" "$INSTDIR\winlirc.dll"

SectionEnd

Section -post
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinLIRC Remote" \
                   "Contact" "tfma@hotmail.com"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinLIRC Remote" \
                   "DisplayIcon" "$INSTDIR\Plugins\uninstall-winlirc-rw.exe"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinLIRC Remote" \
                   "DisplayName" "WinLIRC for ATI Remote Wonder (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinLIRC Remote" \
                   "DisplayVersion" "1.0"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinLIRC Remote" \
                   "Publisher" "Safai Ma"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinLIRC Remote" \
                   "UninstallString" "$INSTDIR\uninstall-winlirc-rw.exe"
  SetOutPath $INSTDIR
  Delete $INSTDIR\uninstall-winlirc-rw.exe 
  WriteUninstaller $INSTDIR\uninstall-winlirc-rw.exe

SectionEnd

Function .onInit

  ; - Is Remote Wonder 1.4 Running? -
  FindWindow $0 "" "ATIX10"
  IsWindow $0 0 IsATIRW15
  StrCpy $2 "atix10.exe"

  Goto MsgBox

  ; - Is Remote Wonder 1.5 Running? -
  IsATIRW15:
  FindWindow $0 "" "ATIRemoteWonder"
  IsWindow $0 0 End
  StrCpy $2 "atirw.exe"

  ; - Remote Wonder is Running -
  MsgBox:
  MessageBox MB_OKCANCEL|MB_ICONEXCLAMATION \
             "ATI Remote Wonder software is currently running. Close it?$\r$\nSetup will restart the software when it is finished" \
             IDCANCEL \
             TerminateInstall

  ; - Close Remote Wonder -
  SendMessage $0 16 0 0

  ; - Set flag to re-start Remote Wonder
  StrCpy $1 "Restart"  

  Goto End

  ; - User Decided to Abort -
  TerminateInstall:
  MessageBox MB_OK|MB_ICONSTOP "ATI Remote Wonder software cannot be running during setup.$\r$\nAborting setup..."
  Abort

  ; - Carry on Install -  
  End:

FunctionEnd

Function .onVerifyInstDir
  IfFileExists $INSTDIR\..\atix10.exe PathGood
  IfFileExists $INSTDIR\..\atirw.exe PathGood
  Abort

  PathGood:
FunctionEnd

Function .onInstSuccess

  ; - Restart Remote Wonder -
  StrCmp $1 "Restart" Restart Finish
  
  Restart:
  Exec "$INSTDIR\..\$2"

  ; - Finish -
  Finish:
FunctionEnd

Function .onInstFailed
  MessageBox MB_OK "There were problems installing WinLIRC Plugin"
FunctionEnd

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Uninstall configuration
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

UninstallText "This will uninstall WinLIRC Plugin from your system."

Section Uninstall
  IfFileExists $INSTDIR\winlirc.dll skip_confirmation
    MessageBox MB_YESNO "It does not appear that WinLIRC Plugin is installed in the directory '$INSTDIR'.$\r$\nContinue anyway (not recommended)" IDYES skip_confirmation
    Abort "Uninstall aborted by user"
  skip_confirmation:

  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\WinLIRC Remote"
  DeleteRegKey HKCU "Software\ATI Technologies\Multimedia\Remote Control\Plug-Ins\WinLIRC"

  ; delete plugins
  Delete "$INSTDIR\winlirc.dll"
  Delete "$INSTDIR\uninstall-winlirc-rw.exe"

  ; - Restart Remote Wonder -
  StrCmp $1 "Restart" Restart Finish
  
  Restart:
  Exec "$INSTDIR\..\$2"

  ; - Finish -
  Finish:

SectionEnd

Function un.onInit

  ; - Is Remote Wonder 1.4 Running? -
  FindWindow $0 "" "ATIX10"
  IsWindow $0 0 IsATIRW15
  StrCpy $2 "atix10.exe"

  Goto MsgBox

  ; - Is Remote Wonder 1.5 Running? -
  IsATIRW15:
  FindWindow $0 "" "ATIRemoteWonder"
  IsWindow $0 0 End
  StrCpy $2 "atirw.exe"

  ; - Remote Wonder is Running -
  MsgBox:
  MessageBox MB_OKCANCEL|MB_ICONEXCLAMATION \
             "ATI Remote Wonder software is currently running. Close it?" \
             IDCANCEL \
             TerminateInstall

  ; - Close Remote Wonder -
  SendMessage $0 16 0 0

  ; - Set flag to re-start Remote Wonder
  StrCpy $1 "Restart"  

  Goto End

  ; - User Decided to Abort -
  TerminateInstall:
  MessageBox MB_OK|MB_ICONSTOP "ATI Remote Wonder software cannot be running during uninstall.$\r$\nAborting uninstall..."
  Abort

  ; - Carry on Uninstall -  
  End:
FunctionEnd
